USE hisab022

select 'B2B' as [1], 'No' AS [2], '' as [3], 'No' AS [4], 'Tax Invoice'  as [5], ItemLedgerForSaleBillPrint.voucher_id as [6], 
FORMAT(ItemLedgerForSaleBillPrint.journal_dt, 'dd/MM/yyyy ') as [7], acclist.GSTN as [8], acclist.accAlias as [9], acclist.nm as [10], 
'WEST BENGAL' as [11],
acclist.identifier as [12], '' as [13], SUBSTRING(UPPER(ItemLedgerForSaleBillPrint.CrAcStateCode),4,LEN(ItemLedgerForSaleBillPrint.CrAcStateCode)) as [14], ItemLedgerForSaleBillPrint.PIN as [15], SUBSTRING(UPPER(ItemLedgerForSaleBillPrint.CrAcStateCode),4,LEN(ItemLedgerForSaleBillPrint.CrAcStateCode)) as [16],
ItemLedgerForSaleBillPrint.Phone as [17], '' as [18], '' as [19], '' as [20], '' as [21], '' as [22],
'' as [23], '' as [24], '' as [25], '' as [26], '' as [27], '' as [28], '' as [29], '' as [30], '' as [31], SUBSTRING(UPPER(ItemLedgerForSaleBillPrint.CrAcStateCode),4,LEN(ItemLedgerForSaleBillPrint.CrAcStateCode)) as [32],
row_number() over(partition by ItemLedgerForSaleBillPrint.voucher_id Order by ItemLedgerForSaleBillPrint.voucher_id) as [33], 
items.nm as [34], 'No' as [35], ItemLedgerForSaleBillPrint.hsn as [36], '' as [37],
cast(round(ItemLedgerForSaleBillPrint.qty,2) as numeric(10,2)) as  [38], cast(round(ItemLedgerForSaleBillPrint.freeqty,2) as numeric(10,2)) as [39], 'UNITS' as [40],
cast(round(ItemLedgerForSaleBillPrint.billRate,2) as numeric(10,2)) as [41],
cast(round(ItemLedgerForSaleBillPrint.gross_amt,2) as numeric(10,2)) as [42],'' as [43], '' as [44], 
cast(round(ItemLedgerForSaleBillPrint.gross_amt,2) as numeric(14,2)) as [45],
ItemLedgerForSaleBillPrint.TaxPercent as [46],
--CASE WHEN SUBSTRING((ItemLedgerForSaleBillPrint.CrAcStateCode),1,2) = 19 THEN cast(round(ItemLedgerForSaleBillPrint.TaxAmt/2,2) as numeric(10,2)) ELSE 0.0 END AS [47],
--CASE WHEN SUBSTRING((ItemLedgerForSaleBillPrint.CrAcStateCode),1,2) = 19 THEN cast(round(ItemLedgerForSaleBillPrint.TaxAmt/2,2) as numeric(10,2)) ELSE 0.0 END AS [48],
--CASE WHEN SUBSTRING((ItemLedgerForSaleBillPrint.CrAcStateCode),1,2) = 19 THEN 0.0 ELSE cast(round(ItemLedgerForSaleBillPrint.TaxAmt,2) as numeric(10,2)) END AS [49], 
cast(round(ItemLedgerForSaleBillPrint.TaxAmt/2,2) as numeric(10,2)) AS [47],
cast(round(ItemLedgerForSaleBillPrint.TaxAmt/2,2) as numeric(10,2)) AS [48],
0.0 AS [49], 
'' as [50], 
cast(round(ItemLedgerForSaleBillPrint.CessPercent,2) as numeric(10,2)) as [51], 
cast(round(ItemLedgerForSaleBillPrint.CessAmt,2) as numeric(10,2)) as [52],
'' as [53], '' as [54], '' as [55], '' as [56],
cast(round(ItemLedgerForSaleBillPrint.NetAmt,2) as numeric(10,2)) as [57], ItemLedgerForSaleBillPrint.mybatch as [58],
ItemLedgerForSaleBillPrint.expdt as [59], 
'' as [60], 
cast(round(Sales.dr_amt,2) as numeric(14,2)) as [61],
--CASE WHEN SUBSTRING((ItemLedgerForSaleBillPrint.CrAcStateCode),1,2) = 19 THEN cast(round(ItemLedgerTotal.TaxAmount/2,2) as numeric(10,2)) ELSE 0.0 END as [62],
--CASE WHEN SUBSTRING((ItemLedgerForSaleBillPrint.CrAcStateCode),1,2) = 19 THEN cast(round(ItemLedgerTotal.TaxAmount/2,2) as numeric(10,2)) ELSE 0.0 END as [63],
--CASE WHEN SUBSTRING((ItemLedgerForSaleBillPrint.CrAcStateCode),1,2) = 19 THEN 0.0 ELSE cast(round(ItemLedgerTotal.TaxAmount,2) as numeric(10,2)) END as [64],
cast(round(ItemLedgerTotal.TaxAmount/2,2) as numeric(10,2)) as [62],
cast(round(ItemLedgerTotal.TaxAmount/2,2) as numeric(10,2)) as [63],
0.0 as [64],
'' as [65], '' as [66],
cast(round(-1*(ItemLedgerForSaleBillPrint.LessAmt ),2) as numeric(10,2)) as [67],
cast(round(Sales.TCSamount,2) as numeric(10,2)) as [68], 
cast(round(ItemLedgerForSaleBillPrint.RoundOffAmt,2) as numeric(4,2)) as [69],
cast(round(Sales.GrossAmt-ItemLedgerForSaleBillPrint.AdjAmt,2) as numeric(14,2)) as [70]
from ItemLedgerForSaleBillPrint
inner join acclist on ItemLedgerForSaleBillPrint.CrAcNm=acclist.nm
inner join items on items.nm=ItemLedgerForSaleBillPrint.nm
inner join journal on journal.hID=ItemLedgerForSaleBillPrint.JournalID
inner join (SELECT JournalID, SUM(NetAmt) AS netAmount, SUM(gross_amt) AS GrossAmt, SUM(TaxAmt) AS TaxAmount
FROM dbo.ItemLedgerForSaleBillPrint
GROUP BY JournalID
) ItemLedgerTotal on ItemLedgerTotal.JournalID=ItemLedgerForSaleBillPrint.JournalID
inner join Sales on Sales.voucher_id=ItemLedgerForSaleBillPrint.voucher_id
where ItemLedgerForSaleBillPrint.journal_dt = '2023-04-15' and len(acclist.GSTN)=15
--AND  ItemLedgerForSaleBillPrint.voucher_id='MKD-7281'
ORDER BY journal.voucher_no